<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'generateProtocolV1' => '\\StructType\\GenerateProtocolV1',
            'dpdServicesParamsV1' => '\\StructType\\DpdServicesParamsV1',
            'pickupAddressDSPV1' => '\\StructType\\PickupAddressDSPV1',
            'sessionDSPV1' => '\\StructType\\SessionDSPV1',
            'packageDSPV1' => '\\StructType\\PackageDSPV1',
            'parcelDSPV1' => '\\StructType\\ParcelDSPV1',
            'authDataV1' => '\\StructType\\AuthDataV1',
            'generateProtocolV1Response' => '\\StructType\\GenerateProtocolV1Response',
            'documentGenerationResponseV1' => '\\StructType\\DocumentGenerationResponseV1',
            'sessionDGRV1' => '\\StructType\\SessionDGRV1',
            'packageDGRV1' => '\\StructType\\PackageDGRV1',
            'parcelDGRV1' => '\\StructType\\ParcelDGRV1',
            'statusInfoDGRV1' => '\\StructType\\StatusInfoDGRV1',
            'generateProtocolV2' => '\\StructType\\GenerateProtocolV2',
            'generateProtocolV2Response' => '\\StructType\\GenerateProtocolV2Response',
            'generateShipmentV1' => '\\StructType\\GenerateShipmentV1',
            'openUMLFeV10' => '\\StructType\\OpenUMLFeV10',
            'packageOpenUMLFeV10' => '\\StructType\\PackageOpenUMLFeV10',
            'parcelOpenUMLFeV4' => '\\StructType\\ParcelOpenUMLFeV4',
            'packageAddressOpenUMLFeV1' => '\\StructType\\PackageAddressOpenUMLFeV1',
            'servicesOpenUMLFeV9' => '\\StructType\\ServicesOpenUMLFeV9',
            'serviceCarryInOpenUMLFeV1' => '\\StructType\\ServiceCarryInOpenUMLFeV1',
            'serviceCODOpenUMLFeV1' => '\\StructType\\ServiceCODOpenUMLFeV1',
            'serviceCODDedicatedAccountOpenUMLFeV1' => '\\StructType\\ServiceCODDedicatedAccountOpenUMLFeV1',
            'serviceCUDOpenUMLeFV1' => '\\StructType\\ServiceCUDOpenUMLeFV1',
            'serviceDeclaredValueOpenUMLFeV1' => '\\StructType\\ServiceDeclaredValueOpenUMLFeV1',
            'serviceDedicatedDeliveryOpenUMLFeV1' => '\\StructType\\ServiceDedicatedDeliveryOpenUMLFeV1',
            'serviceDigitalLabelUMLFeV1' => '\\StructType\\ServiceDigitalLabelUMLFeV1',
            'serviceFlagOpenUMLF' => '\\StructType\\ServiceFlagOpenUMLF',
            'servicePalletOpenUMLFeV1' => '\\StructType\\ServicePalletOpenUMLFeV1',
            'serviceDPDFoodOpenUMLFeV2' => '\\StructType\\ServiceDPDFoodOpenUMLFeV2',
            'serviceDPDLqOpenUMLFeV1' => '\\StructType\\ServiceDPDLqOpenUMLFeV1',
            'serviceDpdPickupOpenUMLFeV1' => '\\StructType\\ServiceDpdPickupOpenUMLFeV1',
            'serviceDutyOpenUMLeFV2' => '\\StructType\\ServiceDutyOpenUMLeFV2',
            'serviceGuaranteeOpenUMLFeV1' => '\\StructType\\ServiceGuaranteeOpenUMLFeV1',
            'serviceInPersOpenUMLFeV1' => '\\StructType\\ServiceInPersOpenUMLFeV1',
            'servicePrivPersOpenUMLFeV1' => '\\StructType\\ServicePrivPersOpenUMLFeV1',
            'serviceRODOpenUMLFeV1' => '\\StructType\\ServiceRODOpenUMLFeV1',
            'serviceSelfColOpenUMLFeV1' => '\\StructType\\ServiceSelfColOpenUMLFeV1',
            'serviceTiresOpenUMLFeV1' => '\\StructType\\ServiceTiresOpenUMLFeV1',
            'serviceTiresExportOpenUMLFeV1' => '\\StructType\\ServiceTiresExportOpenUMLFeV1',
            'generateShipmentV1Response' => '\\StructType\\GenerateShipmentV1Response',
            'shipmentDocumentGenerationResponseV1' => '\\StructType\\ShipmentDocumentGenerationResponseV1',
            'shipmentDocumentGenerationSessionV1' => '\\StructType\\ShipmentDocumentGenerationSessionV1',
            'shipmentDocumentGenerationStatusInfoV1' => '\\StructType\\ShipmentDocumentGenerationStatusInfoV1',
            'generateDomesticReturnLabelV1' => '\\StructType\\GenerateDomesticReturnLabelV1',
            'returnedWaybillsV1' => '\\StructType\\ReturnedWaybillsV1',
            'pudoReturnReceiver' => '\\StructType\\PudoReturnReceiver',
            'generateDomesticReturnLabelV1Response' => '\\StructType\\GenerateDomesticReturnLabelV1Response',
            'generateSpedLabelsV1' => '\\StructType\\GenerateSpedLabelsV1',
            'generateSpedLabelsV1Response' => '\\StructType\\GenerateSpedLabelsV1Response',
            'generateSpedLabelsV4' => '\\StructType\\GenerateSpedLabelsV4',
            'generateSpedLabelsV4Response' => '\\StructType\\GenerateSpedLabelsV4Response',
            'generateSpedLabelsV3' => '\\StructType\\GenerateSpedLabelsV3',
            'generateSpedLabelsV3Response' => '\\StructType\\GenerateSpedLabelsV3Response',
            'generateReturnPackages' => '\\StructType\\GenerateReturnPackages',
            'openUMLFeV7' => '\\StructType\\OpenUMLFeV7',
            'packageOpenUMLFeV7' => '\\StructType\\PackageOpenUMLFeV7',
            'parcelOpenUMLFeV2' => '\\StructType\\ParcelOpenUMLFeV2',
            'servicesOpenUMLFeV6' => '\\StructType\\ServicesOpenUMLFeV6',
            'serviceDPDFoodOpenUMLFeV1' => '\\StructType\\ServiceDPDFoodOpenUMLFeV1',
            'generateReturnPackagesResponse' => '\\StructType\\GenerateReturnPackagesResponse',
            'packagesGenerationResponseV2' => '\\StructType\\PackagesGenerationResponseV2',
            'sessionPGRV2' => '\\StructType\\SessionPGRV2',
            'Packages' => '\\StructType\\Packages',
            'packagePGRV2' => '\\StructType\\PackagePGRV2',
            'ValidationDetails' => '\\StructType\\ValidationDetails',
            'Parcels' => '\\StructType\\Parcels',
            'validationInfoPGRV2' => '\\StructType\\ValidationInfoPGRV2',
            'parcelPGRV2' => '\\StructType\\ParcelPGRV2',
            'generateSpedLabelsV2' => '\\StructType\\GenerateSpedLabelsV2',
            'generateSpedLabelsV2Response' => '\\StructType\\GenerateSpedLabelsV2Response',
            'generatePackagesNumbersV6' => '\\StructType\\GeneratePackagesNumbersV6',
            'openUMLFeV5' => '\\StructType\\OpenUMLFeV5',
            'packageOpenUMLFeV5' => '\\StructType\\PackageOpenUMLFeV5',
            'parcelOpenUMLFeV1' => '\\StructType\\ParcelOpenUMLFeV1',
            'generatePackagesNumbersV6Response' => '\\StructType\\GeneratePackagesNumbersV6Response',
            'generatePackagesNumbersV7' => '\\StructType\\GeneratePackagesNumbersV7',
            'openUMLFeV8' => '\\StructType\\OpenUMLFeV8',
            'packageOpenUMLFeV8' => '\\StructType\\PackageOpenUMLFeV8',
            'parcelOpenUMLFeV3' => '\\StructType\\ParcelOpenUMLFeV3',
            'servicesOpenUMLFeV8' => '\\StructType\\ServicesOpenUMLFeV8',
            'generatePackagesNumbersV7Response' => '\\StructType\\GeneratePackagesNumbersV7Response',
            'generatePackagesNumbersV8' => '\\StructType\\GeneratePackagesNumbersV8',
            'openUMLFeV9' => '\\StructType\\OpenUMLFeV9',
            'packageOpenUMLFeV9' => '\\StructType\\PackageOpenUMLFeV9',
            'generatePackagesNumbersV8Response' => '\\StructType\\GeneratePackagesNumbersV8Response',
            'generatePackagesNumbersV9' => '\\StructType\\GeneratePackagesNumbersV9',
            'openUMLFeV11' => '\\StructType\\OpenUMLFeV11',
            'packageOpenUMLFeV11' => '\\StructType\\PackageOpenUMLFeV11',
            'servicesOpenUMLFeV11' => '\\StructType\\ServicesOpenUMLFeV11',
            'servicePudoToSendUMLFeV1' => '\\StructType\\ServicePudoToSendUMLFeV1',
            'generatePackagesNumbersV9Response' => '\\StructType\\GeneratePackagesNumbersV9Response',
            'findPostalCodeV1' => '\\StructType\\FindPostalCodeV1',
            'postalCodeV1' => '\\StructType\\PostalCodeV1',
            'findPostalCodeV1Response' => '\\StructType\\FindPostalCodeV1Response',
            'findPostalCodeResponseV1' => '\\StructType\\FindPostalCodeResponseV1',
            'generateInternationalPackageNumbersV1' => '\\StructType\\GenerateInternationalPackageNumbersV1',
            'internationalOpenUMLFeV1' => '\\StructType\\InternationalOpenUMLFeV1',
            'internationalPackageOpenUMLFeV1' => '\\StructType\\InternationalPackageOpenUMLFeV1',
            'internationalParcelOpenUMLFeV1' => '\\StructType\\InternationalParcelOpenUMLFeV1',
            'internationalServicesOpenUMLFeV1' => '\\StructType\\InternationalServicesOpenUMLFeV1',
            'serviceDPDPudoReturnUMLFeV1' => '\\StructType\\ServiceDPDPudoReturnUMLFeV1',
            'generateInternationalPackageNumbersV1Response' => '\\StructType\\GenerateInternationalPackageNumbersV1Response',
            'generatePackagesNumbersV1' => '\\StructType\\GeneratePackagesNumbersV1',
            'openUMLFeV1' => '\\StructType\\OpenUMLFeV1',
            'packageOpenUMLFeV1' => '\\StructType\\PackageOpenUMLFeV1',
            'servicesOpenUMLFeV2' => '\\StructType\\ServicesOpenUMLFeV2',
            'serviceDutyOpenUMLeFV1' => '\\StructType\\ServiceDutyOpenUMLeFV1',
            'generatePackagesNumbersV1Response' => '\\StructType\\GeneratePackagesNumbersV1Response',
            'packagesGenerationResponseV1' => '\\StructType\\PackagesGenerationResponseV1',
            'sessionPGRV1' => '\\StructType\\SessionPGRV1',
            'packagePGRV1' => '\\StructType\\PackagePGRV1',
            'invalidFieldPGRV1' => '\\StructType\\InvalidFieldPGRV1',
            'parcelPGRV1' => '\\StructType\\ParcelPGRV1',
            'generatePackagesNumbersV2' => '\\StructType\\GeneratePackagesNumbersV2',
            'generatePackagesNumbersV2Response' => '\\StructType\\GeneratePackagesNumbersV2Response',
            'generatePackagesNumbersV3' => '\\StructType\\GeneratePackagesNumbersV3',
            'openUMLFeV2' => '\\StructType\\OpenUMLFeV2',
            'packageOpenUMLFeV2' => '\\StructType\\PackageOpenUMLFeV2',
            'servicesOpenUMLFeV3' => '\\StructType\\ServicesOpenUMLFeV3',
            'generatePackagesNumbersV3Response' => '\\StructType\\GeneratePackagesNumbersV3Response',
            'generatePackagesNumbersV4' => '\\StructType\\GeneratePackagesNumbersV4',
            'openUMLFeV3' => '\\StructType\\OpenUMLFeV3',
            'packageOpenUMLFeV3' => '\\StructType\\PackageOpenUMLFeV3',
            'servicesOpenUMLFeV4' => '\\StructType\\ServicesOpenUMLFeV4',
            'generatePackagesNumbersV4Response' => '\\StructType\\GeneratePackagesNumbersV4Response',
            'generatePackagesNumbersV5' => '\\StructType\\GeneratePackagesNumbersV5',
            'openUMLFeV4' => '\\StructType\\OpenUMLFeV4',
            'packageOpenUMLFeV4' => '\\StructType\\PackageOpenUMLFeV4',
            'servicesOpenUMLFeV5' => '\\StructType\\ServicesOpenUMLFeV5',
            'generatePackagesNumbersV5Response' => '\\StructType\\GeneratePackagesNumbersV5Response',
            'packagesPickupCallV3' => '\\StructType\\PackagesPickupCallV3',
            'dpdPickupCallParamsV3' => '\\StructType\\DpdPickupCallParamsV3',
            'pickupCallSimplifiedDetailsDPPV1' => '\\StructType\\PickupCallSimplifiedDetailsDPPV1',
            'pickupPackagesParamsDPPV1' => '\\StructType\\PickupPackagesParamsDPPV1',
            'pickupCustomerDPPV1' => '\\StructType\\PickupCustomerDPPV1',
            'pickupPayerDPPV1' => '\\StructType\\PickupPayerDPPV1',
            'pickupSenderDPPV1' => '\\StructType\\PickupSenderDPPV1',
            'packagesPickupCallV3Response' => '\\StructType\\PackagesPickupCallV3Response',
            'packagesPickupCallResponseV3' => '\\StructType\\PackagesPickupCallResponseV3',
            'statusInfoPCRV2' => '\\StructType\\StatusInfoPCRV2',
            'errorDetailsPCRV2' => '\\StructType\\ErrorDetailsPCRV2',
            'packagesPickupCallV4' => '\\StructType\\PackagesPickupCallV4',
            'packagesPickupCallV4Response' => '\\StructType\\PackagesPickupCallV4Response',
            'packagesPickupCallV1' => '\\StructType\\PackagesPickupCallV1',
            'dpdPickupCallParamsV1' => '\\StructType\\DpdPickupCallParamsV1',
            'contactInfoDPPV1' => '\\StructType\\ContactInfoDPPV1',
            'protocolDPPV1' => '\\StructType\\ProtocolDPPV1',
            'packagesPickupCallV1Response' => '\\StructType\\PackagesPickupCallV1Response',
            'packagesPickupCallResponseV1' => '\\StructType\\PackagesPickupCallResponseV1',
            'protocolPCRV1' => '\\StructType\\ProtocolPCRV1',
            'statusInfoPCRV1' => '\\StructType\\StatusInfoPCRV1',
            'packagesPickupCallV2' => '\\StructType\\PackagesPickupCallV2',
            'dpdPickupCallParamsV2' => '\\StructType\\DpdPickupCallParamsV2',
            'packagesPickupCallV2Response' => '\\StructType\\PackagesPickupCallV2Response',
            'packagesPickupCallResponseV2' => '\\StructType\\PackagesPickupCallResponseV2',
            'appendParcelsToPackageV1' => '\\StructType\\AppendParcelsToPackageV1',
            'parcelsAppendV1' => '\\StructType\\ParcelsAppendV1',
            'parcelsAppendSearchCriteriaPAV1' => '\\StructType\\ParcelsAppendSearchCriteriaPAV1',
            'parcelAppendPAV1' => '\\StructType\\ParcelAppendPAV1',
            'appendParcelsToPackageV1Response' => '\\StructType\\AppendParcelsToPackageV1Response',
            'parcelsAppendResponseV1' => '\\StructType\\ParcelsAppendResponseV1',
            'invalidFieldPAV1' => '\\StructType\\InvalidFieldPAV1',
            'parcelsAppendParcelPAV1' => '\\StructType\\ParcelsAppendParcelPAV1',
            'generateReturnLabelV1' => '\\StructType\\GenerateReturnLabelV1',
            'generateReturnLabelV1Response' => '\\StructType\\GenerateReturnLabelV1Response',
            'getCourierOrderAvailabilityV1' => '\\StructType\\GetCourierOrderAvailabilityV1',
            'senderPlaceV1' => '\\StructType\\SenderPlaceV1',
            'getCourierOrderAvailabilityV1Response' => '\\StructType\\GetCourierOrderAvailabilityV1Response',
            'getCourierOrderAvailabilityResponseV1' => '\\StructType\\GetCourierOrderAvailabilityResponseV1',
            'courierOrderAvailabilityRangeV1' => '\\StructType\\CourierOrderAvailabilityRangeV1',
            'appendParcelsToPackageV2' => '\\StructType\\AppendParcelsToPackageV2',
            'parcelsAppendV2' => '\\StructType\\ParcelsAppendV2',
            'parcelAppendPAV2' => '\\StructType\\ParcelAppendPAV2',
            'appendParcelsToPackageV2Response' => '\\StructType\\AppendParcelsToPackageV2Response',
            'generateProtocolsWithDestinationsV1' => '\\StructType\\GenerateProtocolsWithDestinationsV1',
            'dpdServicesParamsV2' => '\\StructType\\DpdServicesParamsV2',
            'DeliveryDestinations' => '\\StructType\\DeliveryDestinations',
            'sessionDSPV2' => '\\StructType\\SessionDSPV2',
            'packageDSPV2' => '\\StructType\\PackageDSPV2',
            'parcelDSPV2' => '\\StructType\\ParcelDSPV2',
            'pickupAddressDSPV2' => '\\StructType\\PickupAddressDSPV2',
            'deliveryDestination' => '\\StructType\\DeliveryDestination',
            'DepotList' => '\\StructType\\DepotList',
            'protocolDepot' => '\\StructType\\ProtocolDepot',
            'generateProtocolsWithDestinationsV1Response' => '\\StructType\\GenerateProtocolsWithDestinationsV1Response',
            'documentGenerationResponseV2' => '\\StructType\\DocumentGenerationResponseV2',
            'DestinationDataList' => '\\StructType\\DestinationDataList',
            'destinationsData' => '\\StructType\\DestinationsData',
            'nonMatchingData' => '\\StructType\\NonMatchingData',
            'sessionDGRV2' => '\\StructType\\SessionDGRV2',
            'packageDGRV2' => '\\StructType\\PackageDGRV2',
            'parcelDGRV2' => '\\StructType\\ParcelDGRV2',
            'statusInfoDGRV2' => '\\StructType\\StatusInfoDGRV2',
            'generateProtocolsWithDestinationsV2' => '\\StructType\\GenerateProtocolsWithDestinationsV2',
            'generateProtocolsWithDestinationsV2Response' => '\\StructType\\GenerateProtocolsWithDestinationsV2Response',
            'importDeliveryBusinessEventV1' => '\\StructType\\ImportDeliveryBusinessEventV1',
            'dpdParcelBusinessEventV1' => '\\StructType\\DpdParcelBusinessEventV1',
            'dpdParcelBusinessEventDataV1' => '\\StructType\\DpdParcelBusinessEventDataV1',
            'importDeliveryBusinessEventV1Response' => '\\StructType\\ImportDeliveryBusinessEventV1Response',
            'importDeliveryBusinessEventResponseV1' => '\\StructType\\ImportDeliveryBusinessEventResponseV1',
            'DPDServiceException' => '\\StructType\\DPDServiceException',
            'Exception' => '\\StructType\\Exception',
            'DeniedAccessWSException' => '\\StructType\\DeniedAccessWSException',
            'SchemaValidationException' => '\\StructType\\SchemaValidationException',
        );
    }
}
