<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeliveryDestinations StructType
 * @subpackage Structs
 */
class DeliveryDestinations extends AbstractStructBase
{
    /**
     * The DeliveryDestination
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DeliveryDestination[]
     */
    public $DeliveryDestination;
    /**
     * Constructor method for DeliveryDestinations
     * @uses DeliveryDestinations::setDeliveryDestination()
     * @param \StructType\DeliveryDestination[] $deliveryDestination
     */
    public function __construct(array $deliveryDestination = array())
    {
        $this
            ->setDeliveryDestination($deliveryDestination);
    }
    /**
     * Get DeliveryDestination value
     * @return \StructType\DeliveryDestination[]|null
     */
    public function getDeliveryDestination()
    {
        return $this->DeliveryDestination;
    }
    /**
     * This method is responsible for validating the values passed to the setDeliveryDestination method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeliveryDestination method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeliveryDestinationForArrayConstraintsFromSetDeliveryDestination(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $deliveryDestinationsDeliveryDestinationItem) {
            // validation for constraint: itemType
            if (!$deliveryDestinationsDeliveryDestinationItem instanceof \StructType\DeliveryDestination) {
                $invalidValues[] = is_object($deliveryDestinationsDeliveryDestinationItem) ? get_class($deliveryDestinationsDeliveryDestinationItem) : sprintf('%s(%s)', gettype($deliveryDestinationsDeliveryDestinationItem), var_export($deliveryDestinationsDeliveryDestinationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeliveryDestination property can only contain items of type \StructType\DeliveryDestination, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeliveryDestination value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryDestination[] $deliveryDestination
     * @return \StructType\DeliveryDestinations
     */
    public function setDeliveryDestination(array $deliveryDestination = array())
    {
        // validation for constraint: array
        if ('' !== ($deliveryDestinationArrayErrorMessage = self::validateDeliveryDestinationForArrayConstraintsFromSetDeliveryDestination($deliveryDestination))) {
            throw new \InvalidArgumentException($deliveryDestinationArrayErrorMessage, __LINE__);
        }
        $this->DeliveryDestination = $deliveryDestination;
        return $this;
    }
    /**
     * Add item to DeliveryDestination value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryDestination $item
     * @return \StructType\DeliveryDestinations
     */
    public function addToDeliveryDestination(\StructType\DeliveryDestination $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryDestination) {
            throw new \InvalidArgumentException(sprintf('The DeliveryDestination property can only contain items of type \StructType\DeliveryDestination, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeliveryDestination[] = $item;
        return $this;
    }
}
