<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for destinationsData StructType
 * @subpackage Structs
 */
class DestinationsData extends AbstractStructBase
{
    /**
     * The DestinationName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DestinationName;
    /**
     * The DocumentId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DocumentId;
    /**
     * The Domestic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Domestic;
    /**
     * Constructor method for destinationsData
     * @uses DestinationsData::setDestinationName()
     * @uses DestinationsData::setDocumentId()
     * @uses DestinationsData::setDomestic()
     * @param string $destinationName
     * @param string $documentId
     * @param bool $domestic
     */
    public function __construct($destinationName = null, $documentId = null, $domestic = null)
    {
        $this
            ->setDestinationName($destinationName)
            ->setDocumentId($documentId)
            ->setDomestic($domestic);
    }
    /**
     * Get DestinationName value
     * @return string|null
     */
    public function getDestinationName()
    {
        return $this->DestinationName;
    }
    /**
     * Set DestinationName value
     * @param string $destinationName
     * @return \StructType\DestinationsData
     */
    public function setDestinationName($destinationName = null)
    {
        // validation for constraint: string
        if (!is_null($destinationName) && !is_string($destinationName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destinationName, true), gettype($destinationName)), __LINE__);
        }
        $this->DestinationName = $destinationName;
        return $this;
    }
    /**
     * Get DocumentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->DocumentId;
    }
    /**
     * Set DocumentId value
     * @param string $documentId
     * @return \StructType\DestinationsData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->DocumentId = $documentId;
        return $this;
    }
    /**
     * Get Domestic value
     * @return bool|null
     */
    public function getDomestic()
    {
        return $this->Domestic;
    }
    /**
     * Set Domestic value
     * @param bool $domestic
     * @return \StructType\DestinationsData
     */
    public function setDomestic($domestic = null)
    {
        // validation for constraint: boolean
        if (!is_null($domestic) && !is_bool($domestic)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($domestic, true), gettype($domestic)), __LINE__);
        }
        $this->Domestic = $domestic;
        return $this;
    }
}
