<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for errorDetailsPCRV2 StructType
 * @subpackage Structs
 */
class ErrorDetailsPCRV2 extends AbstractStructBase
{
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $code;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The fields
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fields;
    /**
     * Constructor method for errorDetailsPCRV2
     * @uses ErrorDetailsPCRV2::setCode()
     * @uses ErrorDetailsPCRV2::setDescription()
     * @uses ErrorDetailsPCRV2::setFields()
     * @param string $code
     * @param string $description
     * @param string $fields
     */
    public function __construct($code = null, $description = null, $fields = null)
    {
        $this
            ->setCode($code)
            ->setDescription($description)
            ->setFields($fields);
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \StructType\ErrorDetailsPCRV2
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\ErrorDetailsPCRV2
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get fields value
     * @return string|null
     */
    public function getFields()
    {
        return $this->fields;
    }
    /**
     * Set fields value
     * @param string $fields
     * @return \StructType\ErrorDetailsPCRV2
     */
    public function setFields($fields = null)
    {
        // validation for constraint: string
        if (!is_null($fields) && !is_string($fields)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fields, true), gettype($fields)), __LINE__);
        }
        $this->fields = $fields;
        return $this;
    }
}
