<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for generateShipmentV1 StructType
 * Meta information extracted from the WSDL
 * - type: tns:generateShipmentV1
 * @subpackage Structs
 */
class GenerateShipmentV1 extends AbstractStructBase
{
    /**
     * The openUMLFeV10
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpenUMLFeV10
     */
    public $openUMLFeV10;
    /**
     * The pkgNumsGenerationPolicyV1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pkgNumsGenerationPolicyV1;
    /**
     * The langCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $langCode;
    /**
     * The outputDocFormatV1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outputDocFormatV1;
    /**
     * The outputDocPageFormatV1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outputDocPageFormatV1;
    /**
     * The outputLabelType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outputLabelType;
    /**
     * The labelVariant
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $labelVariant;
    /**
     * The authDataV1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AuthDataV1
     */
    public $authDataV1;
    /**
     * Constructor method for generateShipmentV1
     * @uses GenerateShipmentV1::setOpenUMLFeV10()
     * @uses GenerateShipmentV1::setPkgNumsGenerationPolicyV1()
     * @uses GenerateShipmentV1::setLangCode()
     * @uses GenerateShipmentV1::setOutputDocFormatV1()
     * @uses GenerateShipmentV1::setOutputDocPageFormatV1()
     * @uses GenerateShipmentV1::setOutputLabelType()
     * @uses GenerateShipmentV1::setLabelVariant()
     * @uses GenerateShipmentV1::setAuthDataV1()
     * @param \StructType\OpenUMLFeV10 $openUMLFeV10
     * @param string $pkgNumsGenerationPolicyV1
     * @param string $langCode
     * @param string $outputDocFormatV1
     * @param string $outputDocPageFormatV1
     * @param string $outputLabelType
     * @param string $labelVariant
     * @param \StructType\AuthDataV1 $authDataV1
     */
    public function __construct(\StructType\OpenUMLFeV10 $openUMLFeV10 = null, $pkgNumsGenerationPolicyV1 = null, $langCode = null, $outputDocFormatV1 = null, $outputDocPageFormatV1 = null, $outputLabelType = null, $labelVariant = null, \StructType\AuthDataV1 $authDataV1 = null)
    {
        $this
            ->setOpenUMLFeV10($openUMLFeV10)
            ->setPkgNumsGenerationPolicyV1($pkgNumsGenerationPolicyV1)
            ->setLangCode($langCode)
            ->setOutputDocFormatV1($outputDocFormatV1)
            ->setOutputDocPageFormatV1($outputDocPageFormatV1)
            ->setOutputLabelType($outputLabelType)
            ->setLabelVariant($labelVariant)
            ->setAuthDataV1($authDataV1);
    }
    /**
     * Get openUMLFeV10 value
     * @return \StructType\OpenUMLFeV10|null
     */
    public function getOpenUMLFeV10()
    {
        return $this->openUMLFeV10;
    }
    /**
     * Set openUMLFeV10 value
     * @param \StructType\OpenUMLFeV10 $openUMLFeV10
     * @return \StructType\GenerateShipmentV1
     */
    public function setOpenUMLFeV10(\StructType\OpenUMLFeV10 $openUMLFeV10 = null)
    {
        $this->openUMLFeV10 = $openUMLFeV10;
        return $this;
    }
    /**
     * Get pkgNumsGenerationPolicyV1 value
     * @return string|null
     */
    public function getPkgNumsGenerationPolicyV1()
    {
        return $this->pkgNumsGenerationPolicyV1;
    }
    /**
     * Set pkgNumsGenerationPolicyV1 value
     * @uses \EnumType\PkgNumsGenerationPolicyV1::valueIsValid()
     * @uses \EnumType\PkgNumsGenerationPolicyV1::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $pkgNumsGenerationPolicyV1
     * @return \StructType\GenerateShipmentV1
     */
    public function setPkgNumsGenerationPolicyV1($pkgNumsGenerationPolicyV1 = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PkgNumsGenerationPolicyV1::valueIsValid($pkgNumsGenerationPolicyV1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PkgNumsGenerationPolicyV1', is_array($pkgNumsGenerationPolicyV1) ? implode(', ', $pkgNumsGenerationPolicyV1) : var_export($pkgNumsGenerationPolicyV1, true), implode(', ', \EnumType\PkgNumsGenerationPolicyV1::getValidValues())), __LINE__);
        }
        $this->pkgNumsGenerationPolicyV1 = $pkgNumsGenerationPolicyV1;
        return $this;
    }
    /**
     * Get langCode value
     * @return string|null
     */
    public function getLangCode()
    {
        return $this->langCode;
    }
    /**
     * Set langCode value
     * @param string $langCode
     * @return \StructType\GenerateShipmentV1
     */
    public function setLangCode($langCode = null)
    {
        // validation for constraint: string
        if (!is_null($langCode) && !is_string($langCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($langCode, true), gettype($langCode)), __LINE__);
        }
        $this->langCode = $langCode;
        return $this;
    }
    /**
     * Get outputDocFormatV1 value
     * @return string|null
     */
    public function getOutputDocFormatV1()
    {
        return $this->outputDocFormatV1;
    }
    /**
     * Set outputDocFormatV1 value
     * @uses \EnumType\OutputDocFormatDSPEnumV1::valueIsValid()
     * @uses \EnumType\OutputDocFormatDSPEnumV1::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $outputDocFormatV1
     * @return \StructType\GenerateShipmentV1
     */
    public function setOutputDocFormatV1($outputDocFormatV1 = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\OutputDocFormatDSPEnumV1::valueIsValid($outputDocFormatV1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OutputDocFormatDSPEnumV1', is_array($outputDocFormatV1) ? implode(', ', $outputDocFormatV1) : var_export($outputDocFormatV1, true), implode(', ', \EnumType\OutputDocFormatDSPEnumV1::getValidValues())), __LINE__);
        }
        $this->outputDocFormatV1 = $outputDocFormatV1;
        return $this;
    }
    /**
     * Get outputDocPageFormatV1 value
     * @return string|null
     */
    public function getOutputDocPageFormatV1()
    {
        return $this->outputDocPageFormatV1;
    }
    /**
     * Set outputDocPageFormatV1 value
     * @uses \EnumType\OutputDocPageFormatDSPEnumV1::valueIsValid()
     * @uses \EnumType\OutputDocPageFormatDSPEnumV1::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $outputDocPageFormatV1
     * @return \StructType\GenerateShipmentV1
     */
    public function setOutputDocPageFormatV1($outputDocPageFormatV1 = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\OutputDocPageFormatDSPEnumV1::valueIsValid($outputDocPageFormatV1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OutputDocPageFormatDSPEnumV1', is_array($outputDocPageFormatV1) ? implode(', ', $outputDocPageFormatV1) : var_export($outputDocPageFormatV1, true), implode(', ', \EnumType\OutputDocPageFormatDSPEnumV1::getValidValues())), __LINE__);
        }
        $this->outputDocPageFormatV1 = $outputDocPageFormatV1;
        return $this;
    }
    /**
     * Get outputLabelType value
     * @return string|null
     */
    public function getOutputLabelType()
    {
        return $this->outputLabelType;
    }
    /**
     * Set outputLabelType value
     * @uses \EnumType\OutputLabelTypeEnumV1::valueIsValid()
     * @uses \EnumType\OutputLabelTypeEnumV1::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $outputLabelType
     * @return \StructType\GenerateShipmentV1
     */
    public function setOutputLabelType($outputLabelType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\OutputLabelTypeEnumV1::valueIsValid($outputLabelType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OutputLabelTypeEnumV1', is_array($outputLabelType) ? implode(', ', $outputLabelType) : var_export($outputLabelType, true), implode(', ', \EnumType\OutputLabelTypeEnumV1::getValidValues())), __LINE__);
        }
        $this->outputLabelType = $outputLabelType;
        return $this;
    }
    /**
     * Get labelVariant value
     * @return string|null
     */
    public function getLabelVariant()
    {
        return $this->labelVariant;
    }
    /**
     * Set labelVariant value
     * @param string $labelVariant
     * @return \StructType\GenerateShipmentV1
     */
    public function setLabelVariant($labelVariant = null)
    {
        // validation for constraint: string
        if (!is_null($labelVariant) && !is_string($labelVariant)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($labelVariant, true), gettype($labelVariant)), __LINE__);
        }
        $this->labelVariant = $labelVariant;
        return $this;
    }
    /**
     * Get authDataV1 value
     * @return \StructType\AuthDataV1|null
     */
    public function getAuthDataV1()
    {
        return $this->authDataV1;
    }
    /**
     * Set authDataV1 value
     * @param \StructType\AuthDataV1 $authDataV1
     * @return \StructType\GenerateShipmentV1
     */
    public function setAuthDataV1(\StructType\AuthDataV1 $authDataV1 = null)
    {
        $this->authDataV1 = $authDataV1;
        return $this;
    }
}
