<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getCourierOrderAvailabilityResponseV1 StructType
 * @subpackage Structs
 */
class GetCourierOrderAvailabilityResponseV1 extends AbstractStructBase
{
    /**
     * The ranges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CourierOrderAvailabilityRangeV1[]
     */
    public $ranges;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * Constructor method for getCourierOrderAvailabilityResponseV1
     * @uses GetCourierOrderAvailabilityResponseV1::setRanges()
     * @uses GetCourierOrderAvailabilityResponseV1::setStatus()
     * @param \StructType\CourierOrderAvailabilityRangeV1[] $ranges
     * @param string $status
     */
    public function __construct(array $ranges = array(), $status = null)
    {
        $this
            ->setRanges($ranges)
            ->setStatus($status);
    }
    /**
     * Get ranges value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CourierOrderAvailabilityRangeV1[]|null
     */
    public function getRanges()
    {
        return isset($this->ranges) ? $this->ranges : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRanges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRanges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRangesForArrayConstraintsFromSetRanges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getCourierOrderAvailabilityResponseV1RangesItem) {
            // validation for constraint: itemType
            if (!$getCourierOrderAvailabilityResponseV1RangesItem instanceof \StructType\CourierOrderAvailabilityRangeV1) {
                $invalidValues[] = is_object($getCourierOrderAvailabilityResponseV1RangesItem) ? get_class($getCourierOrderAvailabilityResponseV1RangesItem) : sprintf('%s(%s)', gettype($getCourierOrderAvailabilityResponseV1RangesItem), var_export($getCourierOrderAvailabilityResponseV1RangesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ranges property can only contain items of type \StructType\CourierOrderAvailabilityRangeV1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ranges value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CourierOrderAvailabilityRangeV1[] $ranges
     * @return \StructType\GetCourierOrderAvailabilityResponseV1
     */
    public function setRanges(array $ranges = array())
    {
        // validation for constraint: array
        if ('' !== ($rangesArrayErrorMessage = self::validateRangesForArrayConstraintsFromSetRanges($ranges))) {
            throw new \InvalidArgumentException($rangesArrayErrorMessage, __LINE__);
        }
        if (is_null($ranges) || (is_array($ranges) && empty($ranges))) {
            unset($this->ranges);
        } else {
            $this->ranges = $ranges;
        }
        return $this;
    }
    /**
     * Add item to ranges value
     * @throws \InvalidArgumentException
     * @param \StructType\CourierOrderAvailabilityRangeV1 $item
     * @return \StructType\GetCourierOrderAvailabilityResponseV1
     */
    public function addToRanges(\StructType\CourierOrderAvailabilityRangeV1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CourierOrderAvailabilityRangeV1) {
            throw new \InvalidArgumentException(sprintf('The ranges property can only contain items of type \StructType\CourierOrderAvailabilityRangeV1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ranges[] = $item;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\GetCourierOrderAvailabilityResponseV1
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
}
