<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for internationalOpenUMLFeV1 StructType
 * @subpackage Structs
 */
class InternationalOpenUMLFeV1 extends AbstractStructBase
{
    /**
     * The packages
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InternationalPackageOpenUMLFeV1[]
     */
    public $packages;
    /**
     * Constructor method for internationalOpenUMLFeV1
     * @uses InternationalOpenUMLFeV1::setPackages()
     * @param \StructType\InternationalPackageOpenUMLFeV1[] $packages
     */
    public function __construct(array $packages = array())
    {
        $this
            ->setPackages($packages);
    }
    /**
     * Get packages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InternationalPackageOpenUMLFeV1[]|null
     */
    public function getPackages()
    {
        return isset($this->packages) ? $this->packages : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPackages method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackages method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackagesForArrayConstraintsFromSetPackages(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $internationalOpenUMLFeV1PackagesItem) {
            // validation for constraint: itemType
            if (!$internationalOpenUMLFeV1PackagesItem instanceof \StructType\InternationalPackageOpenUMLFeV1) {
                $invalidValues[] = is_object($internationalOpenUMLFeV1PackagesItem) ? get_class($internationalOpenUMLFeV1PackagesItem) : sprintf('%s(%s)', gettype($internationalOpenUMLFeV1PackagesItem), var_export($internationalOpenUMLFeV1PackagesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The packages property can only contain items of type \StructType\InternationalPackageOpenUMLFeV1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set packages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InternationalPackageOpenUMLFeV1[] $packages
     * @return \StructType\InternationalOpenUMLFeV1
     */
    public function setPackages(array $packages = array())
    {
        // validation for constraint: array
        if ('' !== ($packagesArrayErrorMessage = self::validatePackagesForArrayConstraintsFromSetPackages($packages))) {
            throw new \InvalidArgumentException($packagesArrayErrorMessage, __LINE__);
        }
        if (is_null($packages) || (is_array($packages) && empty($packages))) {
            unset($this->packages);
        } else {
            $this->packages = $packages;
        }
        return $this;
    }
    /**
     * Add item to packages value
     * @throws \InvalidArgumentException
     * @param \StructType\InternationalPackageOpenUMLFeV1 $item
     * @return \StructType\InternationalOpenUMLFeV1
     */
    public function addToPackages(\StructType\InternationalPackageOpenUMLFeV1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InternationalPackageOpenUMLFeV1) {
            throw new \InvalidArgumentException(sprintf('The packages property can only contain items of type \StructType\InternationalPackageOpenUMLFeV1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->packages[] = $item;
        return $this;
    }
}
